; Script generated by the Inno Setup Script Wizard.
; SEE THE DOCUMENTATION FOR DETAILS ON CREATING INNO SETUP SCRIPT FILES!

[Setup]
AppName=Turgen System
AppVerName=Turgen System 8.4.5
AppPublisher=Michael Kalous
AppPublisherURL=http://turgen.sf.net/
AppSupportURL=http://turgen.sf.net/
AppUpdatesURL=http://turgen.sf.net/
DefaultDirName={pf}\turgen_system
DefaultGroupName=Turgen System
AllowNoIcons=yes
LicenseFile=H:\michael\projects\turgen\doc\COPYING
OutputDir=H:\michael\
OutputBaseFilename=turgen_system-8.4.5-installer
Compression=lzma
SolidCompression=yes
DisableStartupPrompt=no
WindowVisible=no
BackSolid=no
BackColor=$000046
PrivilegesRequired=none
ArchitecturesInstallIn64BitMode=ia64 x64


[Languages]
Name: "english"; MessagesFile: "compiler:Default.isl"

[Tasks]
Name: "desktopicon"; Description: "{cm:CreateDesktopIcon}"; GroupDescription: "{cm:AdditionalIcons}"; Flags: unchecked


[Files]
Source: "H:\michael\turgen_system-8.4.5.bin\turgen.jar"; DestDir: "{app}"; Flags: ignoreversion;
Source: "H:\michael\turgen_system-8.4.5.bin\*"; DestDir: "{app}"; Flags: ignoreversion recursesubdirs createallsubdirs;



; NOTE: Don't use "Flags: ignoreversion" on any shared system files

[Icons]
Name: "{group}\Turgen System"; Filename: "{code:getJRELocation}"; Parameters: "-jar ""{app}\turgen.jar"""; IconFileName: {app}\ts.ico
Name: "{group}\Turgen System Docs"; Filename: "{app}\doc\turgen_system_doc-8.4.5.pdf"
Name: "{group}\Uninstall"; Filename: "{uninstallexe}"
Name: "{userdesktop}\Turgen System";Filename: "{code:getJRELocation}"; Parameters: "-jar ""{app}\turgen.jar""" ; Tasks: desktopicon; IconFileName: {app}\ts.ico


[Code]

var finalJRELocation:String;

procedure InitializeWizard();
var jreLocation:String;
    jreFound:Boolean;
    tmpVersion:String;


begin;

    {Check whether JRE is installed}
    jreFound:=false;
    jreLocation:='';
    finalJRELocation:=jreLocation;
    
    if RegValueExists(HKEY_LOCAL_MACHINE, 'Software\Javasoft\Java Runtime Environment', 'CurrentVersion') then begin;
       if RegQueryStringValue(HKEY_LOCAL_MACHINE, 'Software\Javasoft\Java Runtime Environment','CurrentVersion',tmpVersion)=true then begin;
          if RegQueryStringValue(HKEY_LOCAL_MACHINE, 'Software\Javasoft\Java Runtime Environment\' + tmpVersion,'JavaHome',jreLocation)=true then begin;
             jreLocation:=jreLocation+'\bin\javaw.exe';
             jreFound:=true;
             finalJRELocation:=jreLocation;
             end;
        end;
    end;

    {If not found, show warning}
    if jreFound=false then begin;
      Beep;
      MsgBox('Java Runtime Environment (JRE) not detected !'#13'TURGEN SYSTEM requires JRE version 1.5.0 or later. '#13#13'Download and install JRE first. See http://java.com/en/download/index.jsp'#13#13'If you have JDK installed, locate java launcher manually in the next step.',mbConfirmation, MB_OK);
      
      {Offer to locate manually}
      if MsgBox('Do you want to locate Java launcher (java.exe, javaw.exe) manually?',mbConfirmation,MB_YESNO)=idYes then begin;
         {Locating}
          if GetOpenFileName('Java launcher (java.exe,javaw.exe)',jreLocation,'','','') then begin;
             finalJRELocation:=jreLocation;
          end;

      end; {Manually located}
      
      if finalJRELocation='' then MsgBox('Installer has no information about JRE !'#13#13'Installation will continue, but the shortcuts in the Start menu or on the Desktop will not work.',mbConfirmation,MB_OK);
      
    end; {Not found}
    
end;

function getJRELocation(param:String): String;
begin;
  Result:=finalJRELocation;
end;

